--
-- Use "se ts=3 sw=3" in vim!
--
main
	define
		l_str_report_title      varchar(40),
		l_dt_report             datetime year to second,
		l_str_header_code_caption
										varchar(15),
		l_str_header_name_caption
										varchar(60),
		l_r_country             record
										   country_code      varchar(15),
										   country_name      varchar(60)
									   end record,
		l_r_region              record
										   region_code       varchar(15),
										   region_name       varchar(60)
									   end record,
		l_i                     integer,
		l_n                     integer,
		l_k                     integer,
		l_len_region            integer,
		l_ok                    boolean,
		l_handler               om.SaxDocumentHandler


	call ui.Dialog.setDefaultUnbuffered(true)

	let l_str_report_title = "TEST REPORT"
	let l_dt_report        = current year to second
	let l_str_header_code_caption  = "Code"  
	let l_str_header_name_caption  = "Name"

	--
	-- Before the ".4rp" extension it is a lowercase "l", not the number 1
	--
	call fgl_report_loadCurrentSettings("test0003l.4rp")
		returning l_ok

	if (not l_ok) then
		error "Error loading file \"test0003l.4rp\"."
		exit program 1
	end if

	call fgl_report_selectDevice("SVG")
	--call fgl_report_selectDevice("PDF")
	--call fgl_report_selectDevice("Image")
	--call fgl_report_selectDevice("Printer")

	-- Only for "SVG" e "PDF"
	call fgl_report_selectPreview(true)
	--call fgl_report_selectPreview(false)

	--call fgl_report_setPrinterName ("my_printer_name")
	--call fgl_report_setPrinterCopies(1)

	call fgl_report_commitCurrentSettings() 
		returning l_handler

	--
	-- Defined on "test_0003l.4gl"
	--
	start report rep_test

	for l_i = 1 to 10
		let l_r_country.country_code = l_i using "&&&"
		let l_r_country.country_name = "Country ", l_r_country.country_code

		for l_n = 1 to 15
			let l_r_region.region_code = l_i using "&&&", "_", l_n using "&&&&&&&&&&&"
			let l_r_region.region_name = "Zone ", l_r_region.region_code, " (country ", l_r_country.country_code, ")"

			let l_len_region = length(l_r_region.region_name)

			for l_k = l_len_region + 1 to 60
				let l_r_region.region_name = l_r_region.region_name, "-"
			end for

			output to report rep_test(l_str_report_title,
											  l_dt_report,
											  l_str_header_code_caption,
											  l_str_header_name_caption,
											  l_r_country.*,
											  l_r_region.*)
		end for
	end for

	finish report rep_test

	let l_handler = NULL
end main

--
-- End of file: test0003.4gl
--
